<script lang="ts">
    import Button from "@smui/button";
    import Menu from "@smui/menu";
    import List, { Item } from "@smui/list";
    import exportFromJSON from "export-from-json";
    import type { Repository } from "$lib/types/githubResults.type";

    export let data: any;
    export let fileName: string;

    let open = false;

    $: bibTexUrl = createBibTexUrl(data);
    // Don't change the string format
    function createBibTexUrl(repositories: Repository[]) {
        let bibTexString = "";
        for (let repo of repositories) {
            bibTexString += `@misc{${repo.name},
            title = "${repo.name}",
            doi = "${repo.mainPaper?.doi}",
            month = ${repo.createdAt.getMonth()},
            year = ${repo.createdAt.getFullYear()},
            url  = "${repo.url}",
            note = "Stars: ${repo.stars}; Forks: ${repo.forks};
                    Language: ${repo.language}"
}
`;
        }

        return (
            "data:text/bib;charset=utf-8," + encodeURIComponent(bibTexString)
        );
    }
</script>

<Button on:click={() => (open = true)}>
    <svg
        width="20px"
        height="20px"
        viewBox="0 0 24 24"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
    >
        <path
            d="M16 11L12 15M12 15L8 11M12 15V3M21 15V17C21 18.1046 20.1046 19 19 19H5C3.89543 19 3 18.1046 3 17V15"
            stroke="#000000"
            stroke-width="2"
            stroke-linecap="round"
            stroke-linejoin="round"
        />
    </svg>
</Button>
<Menu style="background: rgba(255,255,255,1)" bind:open>
    <List>
        <Item
            --background="rgba(0,0,0, 1)"
            on:click={() => {
                const exportType = exportFromJSON.types.json;
                exportFromJSON({
                    data,
                    fileName,
                    exportType,
                });
            }}
        >
            JSON
        </Item>
        <Item
            on:click={() => {
                const exportType = exportFromJSON.types.csv;
                exportFromJSON({
                    data,
                    fileName,
                    exportType,
                });
            }}
        >
            CSV
        </Item>
        <Item>
            <!-- name used to be bibTexFileName (change back?) -->
            <a
                class="no-underline text-black"
                href={bibTexUrl}
                download={`${fileName}.bib`}
            >
                BIB
            </a>
        </Item>
    </List>
</Menu>
